Shader "Custom/Player Animated" {
    Properties {
        _Color ("Color", Color) = (0.5,0.5,0.5,0.5)
        _ByX ("By X",Vector)=(0,0,0,0)
        _ByY ("By Y",Vector)=(0,0,0,0)
     }

    SubShader {
        Tags { "Queue" = "Transparent+20" }
        //Blend SrcAlpha OneMinusSrcAlpha
        //AlphaTest Greater .01
        ColorMask RGB
        Lighting Off
        AlphaTest Off
        ZWrite On
        Cull Off

        Pass {
            CGPROGRAM
// Upgrade NOTE: excluded shader from Xbox360; has structs without semantics (struct v2f members uv,color)
#pragma exclude_renderers xbox360
                #pragma vertex vert
                #pragma fragment frag
                #pragma multi_compile_builtin
                #pragma fragmentoption ARB_precision_hint_fastest
                #include "UnityCG.cginc"
               
                uniform float4  _Color;
               	uniform float4 _ByX;                
               	uniform float4 _ByY;                


                struct appdata_vert {
                    float4 vertex : POSITION;
                    float4 texcoord : TEXCOORD0;
                };
                              
                struct v2f {
                    float4 pos : SV_POSITION;
                };
               
                v2f vert (appdata_vert v) {
                    v2f o;
                    o.pos = mul(UNITY_MATRIX_P, mul (UNITY_MATRIX_MV, v.vertex) + _ByX*v.texcoord.x + _ByY*v.texcoord.y);
                    return o;
                }
               
                float4 frag (v2f i) : COLOR {                   
                    return _Color;
                }
            ENDCG
        }
    }
   
	Fallback " VertexLit", 1
}
 