Shader "Custom/Reversed Normal Clip" {
     Properties {
      _Color ("Color", Color) = (0.0,0.0,0.0)
      _Amount ("Amount", Range(0.0,1.0)) = 3.0
    }
    SubShader {
      Tags {"Queue"="Transparent" "IgnoreProjector"="True" "RenderType" = "Transparent" }
      
	//Alphatest Greater 0
	ZWrite Off
	Blend SrcAlpha OneMinusSrcAlpha 
	ColorMask RGB
	Lighting Off
	Cull Back	
	Fog { Mode Off }
      CGPROGRAM
      #pragma surface surf Lambert
      struct Input {
          float3 viewDir;
      };
      
      float4 _Color;
      float _Amount;
      
      void surf (Input IN, inout SurfaceOutput o) {
          half rim = 1.0 - dot (normalize(IN.viewDir), o.Normal);
          if (_Amount>rim)
          {
          	o.Alpha = 0;
          }
          else
          {
          	o.Alpha = _Color.a;
          }
         	
          o.Emission = _Color.rgb;
      }
      ENDCG
    } 
    Fallback "Diffuse"
  }