using UnityEngine;
using System.Collections.Generic;
using System;

public class Dodeca {				
	public Coord coord;
	public List<Face> faces;
	
	public Dodeca (Coord _coord)
	{
		coord = _coord;
		faces = new List<Face>();
		
		for (int i=0;i<12;i++)
		{
			int s = i;
			faces.Add(new Face(coord,s));
		}		
	}
	
	public bool FaceOnSide (int side, out Face result)
	{
		foreach (Face f in faces)
		{
			if (f.side == side)
			{
				result = f;
				return true;
			}
		}		
		
		result = default(Face);
		return false;		
	}
	
	public bool HasFaceOnSide (int side)
	{
		Face result;
		return FaceOnSide(side, out result);
	}
}
