using UnityEngine;
using System.Collections.Generic;

public static class DodecaData
{		
	public static int[] validviewdirs = {
		1,2,3,4,9,10,11,12
	};//indexes into vertices - basically points of degree3
	
	
	public static int[] vertexneighbourdirs = {
		0,5,6,7,8,13
	};//indexes into vertices- basically points of degree4
	
	//maps side into {vertex,vertex}
	public static int[][] sideviewdirs = {
		new int[]{1,2},
		new int[]{2,3},
		new int[]{3,4},
		new int[]{4,1},
		new int[]{1,9},
		new int[]{2,10},
		new int[]{3,11},
		new int[]{4,12},
		new int[]{9,10},
		new int[]{10,11},
		new int[]{11,12},
		new int[]{12,9}
	};
	
	public static Vector3[] dodec_projected_vertices = {
		new Vector3(0,0,0), //0
		new Vector3(-1,-1,0), //1
		new Vector3(-1,1,0), //2 
		new Vector3(1,1,0), //3
		new Vector3(1,-1,0), //4 
		new Vector3(-2,0,0), //5 
		new Vector3(0,2,0), //6 
		new Vector3(2,0,0), //7 
		new Vector3(0,-2,0), //8 
		new Vector3(-3,-3,0), //9 
		new Vector3(-3,3,0), //10
		new Vector3(3,3,0), //11
		new Vector3(3,-3,0), //12
		new Vector3(-4,0,0) //13
	};
	
	public static Vector3[] vertices = {
	//UPPER HALF
	// TOP POINT
		new Vector3(0,2,0),	//		0
	// UPPER RIDGE
		new Vector3(-1,1,-1), // NW	1
		new Vector3(1,1,-1), // NE		2
		new Vector3(1,1,1), // SE		3
		new Vector3(-1,1,1), // SW		4
	// MIDDLE RIDGE
		new Vector3(0,0,-2), // N		5
		new Vector3(2,0,0), // E		6
		new Vector3(0,0,2), // S		7
		new Vector3(-2,0,0), // W		8
	// LOWER RIDGE
		new Vector3(-1,-1,-1), // NW	9
		new Vector3(1,-1,-1), // NE	10
		new Vector3(1,-1,1), // SE		11
		new Vector3(-1,-1,1), // SW	12
	// BOTTOM
		new Vector3(0,-2,0) //			13
	};
	
	//side -> vertex
	public static int[] dodec_tris = {
	//UPPER
	//N
		1,2,0,	5,
	//E
		2,3,0,	6,
	//S
		3,4,0,	7,
	//W
		4,1,0,	8,
	//MIDDLE
	// NW
		8,5,1,	9,
	// NE
		5,6,2,	10,
	// SE
		6,7,3,	11,
	// SW
		7,8,4,	12,		
	//LOWER
	//N
		9,10,5,	13,
	//E
		10,11,6,	13,
	//S
		11,12,7,	13,
	//W
		12,9,8,	13		
	};
	
	public static Vector3[] SideNormal = {
		new Vector3(0f, 0.9899495f, -0.9899495f),
		new Vector3(0.9899495f, 0.9899495f, 0f),
		new Vector3(0f, 0.9899495f, 0.9899495f),
		new Vector3(-0.9899495f, 0.9899495f, 0f),
		new Vector3(-0.9899495f, 0f, -0.9899495f),
		new Vector3(0.9899495f, 0f, -0.9899495f),
		new Vector3(0.9899495f, 0f, 0.9899495f),
		new Vector3(-0.9899495f, 0f, 0.9899495f),
		new Vector3(0f, -0.9899495f, -0.9899495f),
		new Vector3(0.9899495f, -0.9899495f, 0f),
		new Vector3(0f, -0.9899495f, 0.9899495f),
		new Vector3(-0.9899495f, -0.9899495f, 0f),
	};
	
	public static Vector3[] SideForward = {
		new Vector3(1f, 0f, 0f),
		new Vector3(0f, 0f, 1f),
		new Vector3(-1f, 0f, 0f),
		new Vector3(0f, 0f, -1f),
		new Vector3(0f, 2.828427f, 0f),
		new Vector3(0f, 2.828427f, 0f),
		new Vector3(0f, 2.828427f, 0f),
		new Vector3(0f, 2.828427f, 0f),
		new Vector3(1f, 0f, 0f),
		new Vector3(0f, 0f, 1f),
		new Vector3(-1f, 0f, 0f),
		new Vector3(0f, 0f, -1f),
	};
	
	
	//side -> side
	public static int[][] NeighbouringDirs = {
		new int[]{1,3,4,5},
		new int[]{0,2,5,6},
		new int[]{1,3,6,7},
		new int[]{0,2,4,7},
		new int[]{0,3,8,11},
		new int[]{0,1,8,9},
		new int[]{1,2,9,10},
		new int[]{2,3,10,11},
		new int[]{4,5,9,11},
		new int[]{5,6,8,10},
		new int[]{6,7,9,11},
		new int[]{4,7,8,10}
	};
	
	public static Vector3[][] EdgeDirs = {
		new Vector3[]{	new Vector3(0.8164966f, 0.4082483f, 0.4082483f)
		,
			new Vector3(-0.8164966f, 0.4082483f, 0.4082483f)
		,
			new Vector3(-0.8164966f, -0.4082483f, -0.4082483f)
		,
			new Vector3(0.8164966f, -0.4082483f, -0.4082483f)
		},
		new Vector3[]{	new Vector3(-0.4082483f, 0.4082483f, -0.8164966f)
		,
			new Vector3(-0.4082483f, 0.4082483f, 0.8164966f)
		,
			new Vector3(0.4082483f, -0.4082483f, -0.8164966f)
		,
			new Vector3(0.4082483f, -0.4082483f, 0.8164966f)
		},
		new Vector3[]{	new Vector3(0.8164966f, 0.4082483f, -0.4082483f)
		,
			new Vector3(-0.8164966f, 0.4082483f, -0.4082483f)
		,
			new Vector3(0.8164966f, -0.4082483f, 0.4082483f)
		,
			new Vector3(-0.8164966f, -0.4082483f, 0.4082483f)
		},
		new Vector3[]{	new Vector3(0.4082483f, 0.4082483f, -0.8164966f)
		,
			new Vector3(0.4082483f, 0.4082483f, 0.8164966f)
		,
			new Vector3(-0.4082483f, -0.4082483f, -0.8164966f)
		,
			new Vector3(-0.4082483f, -0.4082483f, 0.8164966f)
		},
		new Vector3[]{	new Vector3(0.4082483f, 0.8164966f, -0.4082483f)
		,
			new Vector3(-0.4082483f, 0.8164966f, 0.4082483f)
		,
			new Vector3(0.4082483f, -0.8164966f, -0.4082483f)
		,
			new Vector3(-0.4082483f, -0.8164966f, 0.4082483f)
		},
		new Vector3[]{	new Vector3(-0.4082483f, 0.8164966f, -0.4082483f)
		,
			new Vector3(0.4082483f, 0.8164966f, 0.4082483f)
		,
			new Vector3(-0.4082483f, -0.8164966f, -0.4082483f)
		,
			new Vector3(0.4082483f, -0.8164966f, 0.4082483f)
		},
		new Vector3[]{	new Vector3(0.4082483f, 0.8164966f, -0.4082483f)
		,
			new Vector3(-0.4082483f, 0.8164966f, 0.4082483f)
		,
			new Vector3(0.4082483f, -0.8164966f, -0.4082483f)
		,
			new Vector3(-0.4082483f, -0.8164966f, 0.4082483f)
		},
		new Vector3[]{	new Vector3(0.4082483f, 0.8164966f, 0.4082483f)
		,
			new Vector3(-0.4082483f, 0.8164966f, -0.4082483f)
		,
			new Vector3(0.4082483f, -0.8164966f, 0.4082483f)
		,
			new Vector3(-0.4082483f, -0.8164966f, -0.4082483f)
		},
		new Vector3[]{	new Vector3(-0.8164966f, 0.4082483f, -0.4082483f)
		,
			new Vector3(0.8164966f, 0.4082483f, -0.4082483f)
		,
			new Vector3(0.8164966f, -0.4082483f, 0.4082483f)
		,
			new Vector3(-0.8164966f, -0.4082483f, 0.4082483f)
		},
		new Vector3[]{	new Vector3(0.4082483f, 0.4082483f, -0.8164966f)
		,
			new Vector3(0.4082483f, 0.4082483f, 0.8164966f)
		,
			new Vector3(-0.4082483f, -0.4082483f, -0.8164966f)
		,
			new Vector3(-0.4082483f, -0.4082483f, 0.8164966f)
		},
		new Vector3[]{	new Vector3(0.8164966f, 0.4082483f, 0.4082483f)
		,
			new Vector3(-0.8164966f, 0.4082483f, 0.4082483f)
		,
			new Vector3(0.8164966f, -0.4082483f, -0.4082483f)
		,
			new Vector3(-0.8164966f, -0.4082483f, -0.4082483f)
		},
		new Vector3[]{	new Vector3(-0.4082483f, 0.4082483f, -0.8164966f)
		,
			new Vector3(-0.4082483f, 0.4082483f, 0.8164966f)
		,
			new Vector3(0.4082483f, -0.4082483f, -0.8164966f)
		,
			new Vector3(0.4082483f, -0.4082483f, 0.8164966f)
		}	
	};
	
	public static Vector3[] SideUV = {
		new Vector3(0.1f, 0.1f, 0f),
		new Vector3(0.1f, 0.35f, 0f),
		new Vector3(0.1f, 0.6f, 0f),
		new Vector3(0.1f, 0.85f, 0f),
		new Vector3(0.35f, 0.1f, 0f),
		new Vector3(0.35f, 0.35f, 0f),
		new Vector3(0.35f, 0.6f, 0f),
		new Vector3(0.35f, 0.85f, 0f),
		new Vector3(0.6f, 0.1f, 0f),
		new Vector3(0.6f, 0.35f, 0f),
		new Vector3(0.6f, 0.6f, 0f),
		new Vector3(0.6f, 0.85f, 0f),
	};
	
	public static int[] SideInverse = {
		10,
		11,
		8,
		9,
		6,
		7,
		4,
		5,
		2,
		3,
		0,
		1
	};
	
	//vertex -> [sides]
	public static int[][] NeighbouringSidesOfVertex = {
		new int[]{0,1,2,3},
		new int[]{0,3,4,0},
		new int[]{0,1,5,0},
		new int[]{1,2,6,0},
		new int[]{2,3,7,0},
		new int[]{0,4,5,8},
		new int[]{1,5,6,9},
		new int[]{2,6,7,10},
		new int[]{3,4,7,11},
		new int[]{4,8,11,0},
		new int[]{5,8,9,0},
		new int[]{6,9,10,0},
		new int[]{7,10,11,0},
		new int[]{8,9,10,11}
	};
	
	/*
	static DodecaData ()
	{
		string d = "";
		NeighbouringSidesOfVertex = new int[14][];
		for (int i=0; i<14; i++)
		{
			//three or four depending on vertex
			int[] row = new int[4];
			int rowi = 0;
			//if vertex used in triangle, add side
			for (int j=0; j<12; j++)
			{
				for (int k=0; k<4; k++)
				{
					if (dodec_tris [j * 4 + k] == i)
					{
						row [rowi] = j;
						rowi++;
						break;
					}
				}
			}
			
			NeighbouringSidesOfVertex [i] = row;
		}
		
		d += "Neighbouring sides\n";
		for (int i=0; i<14; i++)
		{
			d += "new int[]{";
			bool divided = false;
			for (int j=0; j<4; j++)
			{
				if (j > 0)
				{
					d+=",";
				}
				d += NeighbouringSidesOfVertex [i] [j];
			}
			d += "},\n";
		}
		Debug.Log(d);
		
	}
		*/
	/*
	private static List<int> _NeighbouringDirs (this int side)
	{
		List<int> result = new List<int>();
		for (int i=0; i<12; i++)
		{
			int s = i;
			float angle = Vector3.Angle(DodecaData.SideNormal[side], DodecaData.SideNormal[s]);
			if (angle > 5 && angle < 85)
			{
				result.Add(s);
			}		
		}		
		return result;
	}
		
	private static List<Vector3> _EdgeDirs (int side)
	{
		List<Vector3> result = new List<Vector3>();
		int[] dirs = DodecaData.NeighbouringDirs [(int)side];
		
		foreach (int o in dirs)
		{
			Vector3 on = DodecaData.SideNormal[o];
			Vector3 v = (on - Vector3.Project(on, DodecaData.SideNormal[side])).normalized;
			result.Add(v);
		}
		return result;			
	}
	
			
	public static Vector3 _SideUV (this int side)
	{
		int s = (int)side;
		int ix = s / 4;
		int iy = s % 4;
		float x = ix / 4.0f;
		float y = iy / 4.0f;
		Vector3 uv = new Vector3(x + 0.1f, y + 0.1f, 0);
		return uv;		
	}
	
	public static int SideInverse (int side)
	{
		float min = 1000.0f;
		int inverse = -1;
		
		for (int i=0; i<12; i++)
		{
			int s = i;
			float cand = Vector3.Dot(DodecaData.SideNormal[side], DodecaData.SideNormal[s]);
			if (cand < min)
			{
				min = cand;
				inverse = s;
			}		
		}		
		return inverse;			
	}
	
	
	static DodecaData ()
	{
	
		List<int> validviewlist = validviewdirs.ToList();
		string d = "";
		sideviewdirs = new int[12][];
		for (int i=0; i<12; i++)
		{
			d += "{";
			bool divided = false;
			for (int j=0; j<4; j++)
			{
				if (validviewdirs.Contains(dodec_tris [i*4+j]))
				{
					d += NeighbouringDirs [i] [j];
					if (divided == false)
					{
						d += ",";
						divided = true;
					}
				}
			}
			d += "},\n";
		}
		Debug.Log(d);
		
		for (int i=0;i<12;i++)
		{
			Debug.Log("inverse " + i+"="+Utility.Inverse(i));
		}
		
		Vector3[] oldsidenormal = SideNormal;
		
		SideNormal = new Vector3[12];
		SideForward = new Vector3[12];
		for (int i = 0; i < 12; i++)
		{
			int iA = dodec_tris [i * 4 + 0];
			int iB = dodec_tris [i * 4 + 1];
			int iC = dodec_tris [i * 4 + 2];
			Vector3 a = vertices [iA];
			Vector3 b = vertices [iB];
			Vector3 c = vertices [iC];
			Vector3 n = Vector3.Cross(c - a, b - a);
			Vector3 cand = n.normalized * 1.4f;
			
			Debug.Log("cand" + i + " " + cand);
			Debug.Log("SideNormal " + oldsidenormal [i]);			
			Debug.Log("diff " + (oldsidenormal [i] - cand));
			Debug.Log("magdiff " + (oldsidenormal [i] - cand).magnitude);
			SideNormal [i] = cand;
			
			SideForward [i] = (b - a).normalized;
			
			if (i >= 4 && i < 8)
			{
				SideForward [i] = Vector3.Cross(SideForward [i], n);
			}
		}				
			
		
		NeighbouringDirs = new int[12][];
		for (int i=0; i<12; i++)
		{
			int s = i;
			List<int> nbs = _NeighbouringDirs(s);
			NeighbouringDirs [i] = nbs.ToArray();
		}	
		
		EdgeDirs = new Vector3[12][];
		for (int i=0; i<12; i++)
		{
			int s = i;
			List<Vector3> nbs = _EdgeDirs(s);
			EdgeDirs [i] = nbs.ToArray();
		}
		
		SideUV = new Vector3[12];
		for (int i=0; i<12; i++)
		{
			int s = i;
			SideUV [i] = _SideUV(s);
		}
		
		
		string logged = "";
		
		
		logged += "\nSideForward\n\n";
		for (int i=0; i<12; i++)
		{
			logged += "new Vector3" + SideForward [i].Print();
			logged += ",\n";
		}
		
		logged += "\nSideNormal\n\n";
		for (int i=0; i<12; i++)
		{
			logged += "new Vector3" + SideNormal[i].Print();
			logged += ",\n";
		}
		
		
		
		logged += "\nNeighbouringdirs\n\n";
		for (int i=0; i<12; i++)
		{
			logged += "{";
			for (int j=0; j<NeighbouringDirs[i].Length; j++)
			{
				if (j > 0)
				{
					logged += ",";
				}
				logged += NeighbouringDirs [i] [j];
			}
			logged += "},\n";			
		}
		
		logged += "\n";
		
		
						
		logged += "\nEdgeDirs2\n\n";
		for (int i=0; i<12; i++)
		{
			logged += "new Vector3[]{";
			for (int j=0; j<EdgeDirs[i].Length; j++)
			{
				if (j > 0)
				{
					logged += ",\n";
				}
				logged += "\tnew Vector3" + EdgeDirs [i][j].Print()+"\n";
			}
			logged += "},\n";			
		}
		
		logged += "\n";
		
		
		
		logged += "\nSideUV\n\n";
		for (int i=0; i<12; i++)
		{
			logged += "new Vector3" + SideUV [i].Print();
			logged += ",\n";
		}
		
		
		Debug.Log(logged);
	
		validviewdirs = new int[8];
		int t = 0;
		for (int i=0; i<14; i++)
		{
			float mind=1000;
			Vector3 cand = DodecaData.vertices [i];
			for (int j=0; j<12; j++)
			{
				int s = j;
				float a = Vector3.Angle(cand, DodecaData.SideNormal[s]);
				if (a < mind)
				{
					mind = a;
				}
			}
			
			if (mind < 40)
			{
				validviewdirs [t] = i;
				t++;
				Debug.Log("allowable dir " + i);
			}
		}
		
		Debug.Log("t = " + t);
		
		
	}
	*/
}
