using UnityEngine;
using System.Collections.Generic;

/*
	Usage:

	// Load my level	
	LevelLoadFade.FadeAndLoadLevel("mylevel", Color.white, 0.5);

	// Reset the current level
	LevelLoadFade.FadeAndLoadLevel(Application.loadedLevel, Color.white, 0.5);
*/
public class FadeAndLoadLevel : MonoBehaviour
{
	public static bool skip = false;
	private float fadetime = 0.6f;
	private float delaytime = 0.0f;
	private static FadeAndLoadLevel instance;
	
	private string targetlevel;
	private bool fadeout=false;
	
	private static bool justloaded=true;
	
	public static void FadeSlow (string _targetlevel)
	{
		instance.delaytime = 0.6f;
		instance.fadetime = 1.2f;
		instance.FadeOut(_targetlevel);
	}
	public static void Fade (string _targetlevel)
	{
		instance.FadeOut(_targetlevel);		
	}
	
	private void FadeOut (string _targetlevel)
	{
		/*
		cr = 154.0f / 255.0f;
		cg = 220.0f / 255.0f;
		cb = 244.0f / 255.0f;
		*/
		cr = 1.0f;
		cg = 1.0f;
		cb = 1.0f;
		
		targetlevel = _targetlevel;	
		fadeout = true;
		StartTime = Time.time;
		gameObject.active = true;
		
	}
	
	/*
	private const float cr =68.0f / 255.0f;
	private const float cg= 163.0f / 255.0f;
	private const float cb= 230.0f / 255.0f;
	 */
	/*
	private float cr = 154.0f / 255.0f;
	private float cg = 220.0f / 255.0f;
	private float cb = 244.0f / 255.0f;
	*/
	
	private float cr = 1.0f;
	private float cg = 1.0f;
	private float cb = 1.0f;
	
	void Awake ()
	{		
		instance = this;
		transform.parent = Camera.mainCamera.transform;
		transform.localPosition = new Vector3(0, 0, 1);
		transform.localRotation = Quaternion.Euler(90, 0, 0);
		transform.localScale = new Vector3(30, 30, 30);
		
		if (justloaded)
		{
			cr = 1;
			cg = 1;
			cb = 1;
			justloaded = false;
		}
		
		renderer.material.color = new Color(cr, cg, cb, 1.0f);
	}

	void Start ()
	{		
		StartTime = Time.time;
	}

	void Update ()
	{
		float t = Time.time - StartTime;
		if (fadeout == false)
		{
			if (t >= fadetime)
			{
				gameObject.active = false;
				//Destroy(this);
			}
			else
			{
				renderer.material.color = new Color(cr, cg, cb, 1 - (t - delaytime) / fadetime);
			}
		}
		else
		{
			if (t >= fadetime+delaytime)
			{
				Application.LoadLevel(targetlevel);
			}
			else
			{
				if (t>delaytime)
				{
					renderer.material.color = new Color(cr, cg, cb, (t-delaytime) / fadetime);
				}
			}			
		}
	}

	private float StartTime;
	
	
}
