using UnityEngine;
using System.Collections;

public static class InputManager {
	
	private static float deadlimit=0.2f;
	private static float deadtime=0.0f;
	public static bool JustPressedMove ()
	{
#if !UNITY_IPHONE
		if (Input.GetMouseButtonDown(0))
		{				
			var ray = Camera.main.ScreenPointToRay(Input.mousePosition);
			if (Physics.Raycast(ray, 1000, 1 << 10))
			{
				return true;
			}
			else
			{
				return false;
			}
		}
		else
		{
			return false;
		}
#else
		if (Input.touchCount==1)
		{	
			deadtime+=Time.deltaTime;
			TouchPhase tp = Input.touches[0].phase;
			if ((tp!=TouchPhase.Ended) &&(tp == TouchPhase.Moved || deadtime > deadlimit))
			{
				return true;			
			}
			else
			{
				if (tp==TouchPhase.Ended && Input.touches[0].tapCount==1)
				{
					return true;
				}
				else
				{
					return false;
				}
			}
		}
		else
		{
			deadtime=0;
			return false;
		}
#endif
	}
	
	public static Vector2 GetAxis ()
	{	
#if !UNITY_IPHONE
		float mx = Input.GetAxis("Mouse X") * 0.02f;
		float my = Input.GetAxis("Mouse Y") * 0.02f;				
		return new Vector2(mx, my);
#else
		float maxtouchmag = -10;
		Touch maxt = default(Touch);
		
		foreach (Touch t in Input.touches)
		{
			float curmag = t.deltaPosition.sqrMagnitude;
			if (curmag > maxtouchmag)
			{
				maxtouchmag = curmag;
				maxt = t;
			}
		}
		
		if (maxtouchmag>0)
		{
			const float scale = 0.002f;
			return maxt.deltaPosition*scale;
		}
		else
		{
			return Vector2.zero;
		}
#endif
	}

	public static bool JustReleasedMove ()
	{
#if !UNITY_IPHONE
		return Input.GetMouseButtonUp(0);
#else
		if (Input.touchCount==1)
		{		
			return false;
		}
		else if (Input.touchCount == 2)
		{
			return true;
		}
		else
		{
			return true;
		}
#endif
	}
	
	public static bool JustPressedRotate ()
	{
#if !UNITY_IPHONE
		if (Input.GetMouseButtonDown(0))
		{				
			var ray = Camera.main.ScreenPointToRay(Input.mousePosition);
			if (Physics.Raycast(ray, 1000, 1 << 10))
			{
				return false;
			}
			else
			{
				return true;
			}
		}
		else
		{
			return false;
		}
#else
		if (Input.touchCount == 2)
		{
			return true;
		}
		else
		{
			return false;
		}
		
#endif
	}
	
	public static bool JustReleasedRotate ()
	{
		return Input.GetMouseButtonUp(0);
		/*
#if !UNITY_IPHONE
		return Input.GetMouseButtonUp(0);
#else
		if (Input.touchCount==1 && Input.touches[0].phase == TouchPhase.Ended)
		{			
			return true;
		}
		else if (Input.touchCount == 2)
		{
			foreach (Touch t in Input.touches)
			{
				if (t.phase == TouchPhase.Ended)
				{
					return false;
				}
			}
		}
#endif		*/
	}	
}
