using UnityEngine;
using System.Collections;
using System.Collections.Generic;
using System;

public static class Utility {

	public static Vector3 AnyOrtho (this Vector3 v)
	{
		if (Vector3.Angle(v, Vector3.up) > 45)
		{
			return Vector3.Cross(v, Vector3.up);
		}
		else
		{
			return Vector3.Cross(v, -Vector3.right);
		}
	}
	
	/*
	public static void Shuffle<T> (this IList<T> ary)
	{
		System.Random rand = new System.Random();
	
		for (int i = ary.Count - 1; i > 0; i--)
		{
			int n = rand.Next(i + 1);
			T a = ary [i];
			ary [i] = ary [n];
			ary [n] = a;
		}	
	}*/
	
	public static string SerializeVector (Vector3 v)
	{
		return v.x + "~" + v.y + "~" + v.z;
	}
	
	public static Vector3 DeserializeVector (string s)
	{
		string[] dats = s.Split('~');
		float x = float.Parse(dats [0]);
		float y = float.Parse(dats [1]);
		float z = float.Parse(dats [2]);
		return new Vector3(x, y, z);
	}
	
	
	public static string Print (this Vector3 v)
	{
		return "("+v.x + "f," + v.y + "f," + v.z+"f)";
	}
	
	public static string concat (this string[] strs)
	{
		string result = "";
		foreach (string s in strs)
		{
			result += s;
		}
		return result;
	}
	
	
	public static Vector3 PivotAbout (this Vector3 x, Vector3 pivot)
	{
		return pivot-(x-pivot);
	}
	public static float DistanceFromLine (this Vector3 p, Vector3 p1, Vector3 p2)
	{
		return (p - Vector3.Project(p, p2 - p1)).magnitude;
	}
		
	public static Color ToColor (this Vector3 v)
	{
		return new Color(v.x, v.y, v.z, 0);
	}
	
	public static Vector3 LinePlaneIntersection(Vector3 Pl, Vector3 Nl, Vector3 Pp, Vector3 Np)
	{
		float d = Vector3.Dot(Pp-Pl,Np)/Vector3.Dot(Nl,Np);
		return Pl+d*Nl;
	}

}
