using UnityEngine;
using System.Collections;

public class TitleOptions : MonoBehaviour {
	
	public GameObject b_newgame;
	public GameObject b_continue;
	public Texture2D sound_on;
	public Texture2D sound_off;
	
	public GameObject touchnote;
	public static int curlevel;
	void Awake ()
	{
		
#if UNITY_IPHONE
			b_newgame.transform.GetChild(0).localScale *= 1.2f;
			b_continue.transform.GetChild(0).localScale *= 1.2f;
#else
		touchnote.active=false;
#endif		
		
		curlevel = SaveManager.GetProgress();
		
		if (curlevel == 0)
		{
			b_newgame.transform.position += b_continue.transform.position;
			b_newgame.transform.position /= 2.0f;
			DestroyImmediate(b_continue);
		}
	
		b_newgame.transform.GetChild(0).renderer.material.color = normal;
		if (b_continue)
		{
			b_continue.transform.GetChild(0).renderer.material.color = normal;
		}
		
		
	}
		

	
	private bool fading=false;
	public static Color highlighted = new Color(0, 0, 0, 61.0f / 255.0f);
	public static Color normal = new Color(0, 0, 0, 31.0f / 255.0f);
	public static Color down = new Color(0, 0, 0, 91.0f / 255.0f);
	
	// Update is called once per frame
	void Update ()
	{	
		if (fading)
		{
			return;
		}
		
		Ray ray = Camera.mainCamera.ScreenPointToRay(Input.mousePosition);
		RaycastHit hit;
		if (Physics.Raycast(ray, out hit, 1000, 1 << 8))
		{		
			GameObject go = hit.collider.gameObject;
			GameObject p = go.transform.parent.gameObject;
			if (b_continue)
			{
				b_continue.transform.GetChild(0).renderer.material.color = b_continue == p ? highlighted : normal;
			}
			b_newgame.transform.GetChild(0).renderer.material.color = b_newgame == p ? highlighted : normal;
			
			
			if (Input.GetMouseButtonDown(0))
			{
				if (p == b_newgame)
				{
					b_newgame.transform.GetChild(0).renderer.material.color = down;
					PlayerPrefs.SetInt("curlevel", 0);
					curlevel = 0;
					SaveManager.SetProgress(curlevel);
					StartGame();
				}
				else
				if (p == b_continue)
				{
					b_continue.transform.GetChild(0).renderer.material.color = down;
					StartGame();
				}
			}
			
		}
		else
		{
			if (b_continue)
			{
				b_continue.transform.GetChild(0).renderer.material.color = normal;
			}
			b_newgame.transform.GetChild(0).renderer.material.color = normal;
		}
	}
	
	void StartGame ()
	{
		fading = true;
		FadeAndLoadLevel.Fade("MainScene");
	}
}
